<!DOCTYPE html>
<html>
<head>
  <title>Artillery report</title>
  <script src='https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js'></script>
  <script src='https://cdnjs.cloudflare.com/ajax/libs/d3/3.5.0/d3.min.js' charset='utf-8'></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/metrics-graphics/2.6.0/metricsgraphics.min.css" />
  <script src="https://cdnjs.cloudflare.com/ajax/libs/metrics-graphics/2.6.0/metricsgraphics.min.js"></script>

  <link href='https://fonts.googleapis.com/css?family=Open+Sans:400,300,700' rel='stylesheet' type='text/css'>
  <link href='https://fonts.googleapis.com/css?family=PT+Serif:400,700,400italic' rel='stylesheet' type='text/css'>
  <link href='https://netdna.bootstrapcdn.com/font-awesome/4.2.0/css/font-awesome.css' rel='stylesheet' type='text/css'>
  <link href='https://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css' rel='stylesheet' type='text/css'>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.10.6/moment.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/3.10.1/lodash.min.js"></script>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.0/ace.js" charset="utf-8"></script>

  <style>
  body, p, li {
    font-family: sans-serif;
    font-size: 10pt;
  }

  h1 {
    font-size: 18pt;
    font-weight: bold;
  }

  #errorsContainer > p {
    color: #009900;
  }

  #footer {
    padding: 1em;
    font-size: 0.8em;
    color: #999;
    text-align: center;
    margin-top: 1em;
    background-color: #eee;
  }
  #editor {
    font-size: 8pt;
    height: 20em;
  }
  </style>

  <script>
  window.Report = {
  "aggregate": {
    "timestamp": "2020-12-17T12:46:49.066Z",
    "scenariosCreated": 3000,
    "scenariosCompleted": 2726,
    "requestsCompleted": 2726,
    "latency": {
      "min": 259.7,
      "max": 68527,
      "median": 32644.9,
      "p95": 64836.1,
      "p99": 67777.3
    },
    "rps": {
      "count": 3000,
      "mean": 20
    },
    "scenarioDuration": {
      "min": 365.2,
      "max": 68529.9,
      "median": 32646.9,
      "p95": 64838.1,
      "p99": 67779.5
    },
    "scenarioCounts": {
      "0": 1534,
      "1": 1466
    },
    "errors": {
      "ESOCKETTIMEDOUT": 274
    },
    "codes": {
      "200": 2726
    },
    "matches": 0,
    "customStats": {},
    "counters": {},
    "scenariosAvoided": 0,
    "phases": [
      {
        "duration": 30,
        "arrivalRate": 100
      }
    ]
  },
  "intermediate": [
    {
      "timestamp": "2020-12-17T12:44:28.925Z",
      "scenariosCreated": 996,
      "scenariosCompleted": 351,
      "requestsCompleted": 351,
      "latency": {
        "min": 259.7,
        "max": 6191.7,
        "median": 3523.4,
        "p95": 5695.1,
        "p99": 6162.9
      },
      "rps": {
        "count": 996,
        "mean": 100.91
      },
      "scenarioDuration": {
        "min": 365.2,
        "max": 6194.3,
        "median": 3526.4,
        "p95": 5698.3,
        "p99": 6165.6
      },
      "scenarioCounts": {
        "0": 507,
        "1": 489
      },
      "errors": {},
      "codes": {
        "200": 351
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 645,
      "pendingRequests": 645,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:44:38.919Z",
      "scenariosCreated": 1000,
      "scenariosCompleted": 297,
      "requestsCompleted": 297,
      "latency": {
        "min": 6176.3,
        "max": 12913.1,
        "median": 9154,
        "p95": 12304.9,
        "p99": 12445.2
      },
      "rps": {
        "count": 1000,
        "mean": 100.1
      },
      "scenarioDuration": {
        "min": 6178.5,
        "max": 12915.1,
        "median": 9156.1,
        "p95": 12308.1,
        "p99": 12448.6
      },
      "scenarioCounts": {
        "0": 515,
        "1": 485
      },
      "errors": {},
      "codes": {
        "200": 297
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1348,
      "pendingRequests": 1348,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:44:48.922Z",
      "scenariosCreated": 1000,
      "scenariosCompleted": 327,
      "requestsCompleted": 327,
      "latency": {
        "min": 12968.3,
        "max": 19303.4,
        "median": 16230.8,
        "p95": 19163.5,
        "p99": 19275.5
      },
      "rps": {
        "count": 1000,
        "mean": 100
      },
      "scenarioDuration": {
        "min": 12971.9,
        "max": 19305.8,
        "median": 16232.7,
        "p95": 19166.6,
        "p99": 19278.1
      },
      "scenarioCounts": {
        "0": 509,
        "1": 491
      },
      "errors": {},
      "codes": {
        "200": 327
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 2021,
      "pendingRequests": 2021,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:44:58.922Z",
      "scenariosCreated": 4,
      "scenariosCompleted": 244,
      "requestsCompleted": 244,
      "latency": {
        "min": 19293.3,
        "max": 26325.4,
        "median": 22577.3,
        "p95": 25602.1,
        "p99": 26268.4
      },
      "rps": {
        "count": 4,
        "mean": 0.4
      },
      "scenarioDuration": {
        "min": 19296.7,
        "max": 26329.1,
        "median": 22580.5,
        "p95": 25604.1,
        "p99": 26270.3
      },
      "scenarioCounts": {
        "0": 3,
        "1": 1
      },
      "errors": {},
      "codes": {
        "200": 244
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1781,
      "pendingRequests": 1781,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:45:08.925Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 211,
      "requestsCompleted": 211,
      "latency": {
        "min": 26636.4,
        "max": 34051,
        "median": 31904.3,
        "p95": 33894.6,
        "p99": 34026.7
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": 26639.1,
        "max": 34054.3,
        "median": 31906.4,
        "p95": 33896.7,
        "p99": 34028.8
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {
        "200": 211
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1570,
      "pendingRequests": 1570,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:45:18.931Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 286,
      "requestsCompleted": 286,
      "latency": {
        "min": 34277.9,
        "max": 41101.1,
        "median": 37816.5,
        "p95": 41063.6,
        "p99": 41091.1
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": 34279.9,
        "max": 41103.5,
        "median": 37821.3,
        "p95": 41065.8,
        "p99": 41094.3
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {
        "200": 286
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1284,
      "pendingRequests": 1284,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:45:28.931Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 246,
      "requestsCompleted": 246,
      "latency": {
        "min": 41136,
        "max": 48287.8,
        "median": 44693.7,
        "p95": 47911.2,
        "p99": 48030.5
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": 41138.1,
        "max": 48290,
        "median": 44695.7,
        "p95": 47913.3,
        "p99": 48032.7
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {
        "200": 246
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1038,
      "pendingRequests": 1038,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:45:38.930Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 271,
      "requestsCompleted": 271,
      "latency": {
        "min": 48428.6,
        "max": 55428.1,
        "median": 52078,
        "p95": 55195.6,
        "p99": 55368.2
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": 48437.1,
        "max": 55432.5,
        "median": 52079.8,
        "p95": 55197.2,
        "p99": 55369.9
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {
        "200": 271
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 767,
      "pendingRequests": 767,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:45:48.926Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 255,
      "requestsCompleted": 255,
      "latency": {
        "min": 55482.2,
        "max": 62638.8,
        "median": 59528.6,
        "p95": 62238.4,
        "p99": 62428.3
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": 55484.7,
        "max": 62640.5,
        "median": 59530.2,
        "p95": 62240.6,
        "p99": 62430.9
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {
        "200": 255
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 512,
      "pendingRequests": 512,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:45:58.926Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 238,
      "requestsCompleted": 238,
      "latency": {
        "min": 62639.6,
        "max": 68527,
        "median": 65186.4,
        "p95": 68041.2,
        "p99": 68512.3
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": 62641.1,
        "max": 68529.9,
        "median": 65189.1,
        "p95": 68042.9,
        "p99": 68515
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {
        "200": 238
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 274,
      "pendingRequests": 274,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:46:08.920Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 0,
      "requestsCompleted": 0,
      "latency": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {},
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 274,
      "pendingRequests": 274,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:46:18.921Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 0,
      "requestsCompleted": 0,
      "latency": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {},
      "errors": {},
      "codes": {},
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 274,
      "pendingRequests": 274,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:46:28.922Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 0,
      "requestsCompleted": 0,
      "latency": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {},
      "errors": {
        "ESOCKETTIMEDOUT": 86
      },
      "codes": {},
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 188,
      "pendingRequests": 274,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:46:38.921Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 0,
      "requestsCompleted": 0,
      "latency": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {},
      "errors": {
        "ESOCKETTIMEDOUT": 93
      },
      "codes": {},
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 95,
      "pendingRequests": 274,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:46:48.921Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 0,
      "requestsCompleted": 0,
      "latency": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {},
      "errors": {
        "ESOCKETTIMEDOUT": 94
      },
      "codes": {},
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1,
      "pendingRequests": 274,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2020-12-17T12:46:49.032Z",
      "scenariosCreated": 0,
      "scenariosCompleted": 0,
      "requestsCompleted": 0,
      "latency": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "rps": {
        "count": 0,
        "mean": null
      },
      "scenarioDuration": {
        "min": null,
        "max": null,
        "median": null,
        "p95": null,
        "p99": null
      },
      "scenarioCounts": {},
      "errors": {
        "ESOCKETTIMEDOUT": 1
      },
      "codes": {},
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 274,
      "scenariosAvoided": 0
    }
  ]
};
  </script>

  <style>
      h1 {
        line-height: 200%;
      }

      body {
          background-color: #fcfcfc;
      }

      .container {
          width: 100%;
          min-width: 960px;
      }
  </style>


</head>
<body>

<div class="container">

<div class="row" id="header">
  <div class="col-lg-4 col-lg-offset-4">
    <pre style="font-size: 5pt; background-color: #fcfcfc; border: none;">
            _   _ _ _                                                _
  __ _ _ __| |_(_) | | ___ _ __ _   _      _ __ ___ _ __   ___  _ __| |_
 / _` | '__| __| | | |/ _ \ '__| | | |    | '__/ _ \ '_ \ / _ \| '__| __|
| (_| | |  | |_| | | |  __/ |  | |_| |    | | |  __/ |_) | (_) | |  | |_
 \__,_|_|   \__|_|_|_|\___|_|   \__, |    |_|  \___| .__/ \___/|_|   \__|
                                |___/              |_|

    </pre>
  </div>
</div>

<div class="row">
  <div class="col-lg-12">
    <h1 class="text-center" id="page-title">Test run on <span id="timestamp">date</span></h1>
  </div>
</div>

<div class="row">
  <div class="col-lg-3">
    <p><strong>Summary</strong></p>
    <table class="table table-bordered table-hover table-condensed">
      <tbody>
        <tr>
          <td>Test duration</td>
          <td><span id="testDuration">0</span> sec</td>
        </tr>
        <tr>
          <td>Scenarios created</td>
          <td><span id="scenariosCreated">0</span></td>
        </tr>

        <tr>
          <td>Scenarios completed</td>
          <td><span id="scenariosCompleted">0</span></td>
        </tr>
      </tbody>
    </table>
  </div>

  <div class="col-lg-5" id="scenarioCountsContainer">
    <div>
      <strong>Scenario counts:</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="scenarioCounts">
      </table>
    </div>
  </div>

  <div class="col-lg-1">
    <div id="codesContainer">
      <strong>Codes</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="codes">
      </table>
    </div>
  </div>

  <div class="col-lg-3">
    <div id="errorsContainer">
      <strong>Errors</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="errors">
      </table>
    </div>
  </div>
</div> <!-- /.row -->

<div class="row">
  <div class="text-center col-lg-12">
    <h2>Charts</h2>
  </div>
</div>

<div class="row">
  <div class="latency-histogram text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="latency text-center col-lg-12"></div>
</div>

<div class="latency-legend"></div>

<div class="row">

</div>

<div class="row">
  <div class="concurrency text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="rps-mean text-center col-lg-12"></div>
</div>
<div class="row">
  <div class="rps-count text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="codes-line text-center col-lg-12"></div>
</div>
<div class="row">
  <div class="errors-line text-center col-lg-12"></div>
</div>


  


</div>

<div class="row">
  <div class="col-lg-8 col-lg-offset-2">
    <h3 class="text-center">Raw report data</h3>
    <p>This is the raw JSON stats output that the report was generated from.</p>
    <div id="editor">
    </div>
  </div>
</div>

<script>
var editor = ace.edit("editor");
editor.getSession().setMode("ace/mode/javascript");
editor.setValue(JSON.stringify(Report, null, 2));
editor.gotoLine(1);editor.setHighlightActiveLine(false);

var l = _;

$('#timestamp').html(moment(Report.aggregate.timestamp).format('DD MMM YYYY HH:mm:SS'));
$('#testDuration').html(l.size(Report.intermediate) * 10);
$('#scenariosCompleted').html(Report.aggregate.scenariosCompleted);
$('#scenariosCreated').html(Report.aggregate.scenariosCreated);

var markers = [];
if(l.size(Report.phases) > 0) {
  markers = l.foldl(Report.phases, function(acc, phase, index) {
    var label = phase.name || 'Phase ' + (index + 1);
    var timestamp = (index === 0) ? 0 : Report.phases[index - 1].duration + acc[index - 1].timestamp;

    acc.push({
      timestamp: timestamp,
      label: label
    });

    return acc;
  }, []);
}

if (l.size(Report.aggregate.scenarioCounts) > 0) {
  l.each(Report.aggregate.scenarioCounts, function(count, name) {
    var $tdName = $('<td>' + name + '</td>');
    var percentage = Math.round(count / Report.aggregate.scenariosCreated * 100 * 1000) / 1000;
    var $tdCount = $('<td>' + count + ' (' + percentage + '%)' + '</td>');
    var $el = $('<tr></tr>')
      .append($tdName)
      .append($tdCount)
      .appendTo($('#scenarioCounts'));
  });
} else {
  $('#scenarioCountsContainer').hide();
}

if (l.size(Report.aggregate.codes) > 0) {
  l.each(Report.aggregate.codes, function(count, code) {
    var anchor = '';
    if (code >= 100 && code < 200) {
      anchor = '#1xx_Informational';
    } else if (code >= 200 && code < 300) {
      anchor = '#2xx_Success';
    } else if (code >= 300 && code < 400) {
      anchor = '#3xx_Redirection';
    } else if (code >= 400 && code < 500) {
      anchor = '#4xx_Client_Error';
    } else if (code >= 500 && code < 600) {
      anchor = '#5xx_Server_Error';
    }

    var $a = $('<a>' + code + '</a>').attr('href', 'https://en.wikipedia.org/wiki/List_of_HTTP_status_codes' + anchor);
    var $td = $('<td></td>').append($a);
    var $el = $('<tr></tr>')
      .append($td)
      .append($('<td>' + count + '</td>'))
      .appendTo($('#codes'));
  });
} else {
  $('#codesContainer').hide();
}

if (l.size(Report.aggregate.errors) > 0) {
  l.each(Report.aggregate.errors, function(count, code) {
    var $el = $('<tr></tr>')
      .append($('<td>' + code + '</td>'))
      .append($('<td>' + count + '</td>'))
      .appendTo($('#errors'));
  });
} else {
  $('#errorsContainer > p').html('&#10004; Test completed without network or OS errors.');
}

var histogramData = l.map(Report.aggregate.latency, function(v, k) { return {bin: k, value: v} });

MG.data_graphic({
  chart_type: 'bar',
  x_label: 'Percentile',
  y_label: '(ms)',
  animate_on_load: true,
  title: 'Overall Latency Distribution',
  description: 'Distribution of all observed response latencies',
  target: '.latency-histogram',
  data: histogramData,
  x_accessor: 'bin',
  y_accessor: 'value',
  binned: true,
  height: 250,
  interpolate: 'monotone',
  padding_percentage: 0,
  bar_orientation: 'vertical',
  width: 450
});

var chartData = l.map(
  window.Report.intermediate,
  function(o,i) {
    return {
      timestamp: i*10+10,

      rpsMean: o.rps.mean,
      rpsCount: o.rps.count,
      concurrency: o.concurrency,
      latencyMax: o.latency.max,
      latencyp99: o.latency.p99,
      latencyp95: o.latency.p95,
      latencyMedian: o.latency.median,
      latencyMin: o.latency.min
    }
  });

//
// Response codes
//

if (l.size(Report.aggregate.codes) > 0) {
  var codesData = l.foldl(Report.intermediate, function(acc, o, i) {
    var res = {};
    res.timestamp = i*10+10;
    l.each(o.codes, function(count, code) {
      res[code] = count;
    });
    acc.push(res);
    return acc;
  }, []);
  var uniqueCodes = l.foldl(Report.intermediate, function(acc, o) {
    l.each(o.codes, function(count, code) {
      if (l.indexOf(acc, code) === -1) {
        acc.push(code);
      }
    });
    return acc;
  }, []);

  MG.data_graphic({
    x_label: 'Time',
    y_label: 'Count',
    title: 'HTTP codes',
    description: 'Occurence of HTTP response codes',
    target: '.codes-line',
    data: codesData,
    x_accessor: 'timestamp',
    y_accessor: uniqueCodes,
    legend: uniqueCodes,
    right: 50,
    chart_type: 'line',
    area: false,
    markers: markers,
    width: 900
  });
}

//
// Errors
//

if (l.size(Report.aggregate.errors) > 0) {
  var errorData = l.foldl(Report.intermediate, function(acc, o, i) {
    var res = {};
    res.timestamp = i*10+10;
    l.each(o.errors, function(count, name) {
      res[name] = count;
    });
    acc.push(res);
    return acc;
  }, []);
  var uniqueErrors = l.foldl(Report.intermediate, function(acc, o) {
    l.each(o.errors, function(count, name) {
      if (l.indexOf(acc, name) === -1) {
        acc.push(name);
      }
    });
    return acc;
  }, []);

  MG.data_graphic({
    title: 'Error Codes',
    description: 'Occurence of error codes',
    target: '.errors-line',
    data: errorData,
    x_accessor: 'timestamp',
    y_accessor: uniqueErrors,
    chart_type: 'line',
    area: false,
    markers: markers
  });

}

//
// Latency
//
MG.data_graphic({
  chart_type: 'line',
  x_label: 'Time',
  y_label: '(ms)',
  animate_on_load: true,
  area: false,
  title: "Latency At Intervals",
  description: "Latency values at different points during the test run",
  data: chartData,
  target: '.latency',
  width: 900,
  x_accessor: 'timestamp',
  y_accessor: ['latencyMin', 'latencyMedian', 'latencyp95', 'latencyMax'],
  legend: ['min', 'p50', 'p95', 'max'],
  //legend_target: '.latency-legend',
  right: 50,
  interpolate: 'monotone',
  mouseover: function(d, i) {
  },
  markers: markers
        });

            MG.data_graphic({
            animate_on_load: true,
            area: false,
            y_label: 'Count',
            x_label: 'Time',
            title: 'Concurrent users',
            description: 'Concurrent users',
            data: chartData,
            target: '.concurrency',
            x_accessor: 'timestamp',
            y_accessor: ['concurrency'],
            interpolate: 'monotone',
            markers: markers,
            width: 900
            });

MG.data_graphic({
  animate_on_load: true,
  area: false,
  y_label: 'Count',
  x_label: 'Time',
  title: 'Mean RPS',
  description: 'Mean requests per second',
  data: chartData,
  target: '.rps-mean',
  x_accessor: 'timestamp',
  y_accessor: ['rpsMean'],
  interpolate: 'monotone',
  markers: markers,
  width: 900
});

MG.data_graphic({
  animate_on_load: true,
  area: false,
  y_label: 'Count',
  x_label: 'Time',
  title: 'RPS Count',
  description: 'Count of requests per second',
  data: chartData,
  target: '.rps-count',
  x_accessor: 'timestamp',
  y_accessor: ['rpsCount'],
  interpolate: 'monotone',
  markers: markers,
  width: 900
});
</script>
<div id="footer">
  <footer>This report was created with <a href="https://artillery.io">Artillery</a> - free open-source load-testing for HTTP and WebSockets</footer>
</div>
</body>
</html>
